/*
 * derived from mythgame
*/
#include <qapplication.h>
#include <qregexp.h>
#include <stdlib.h>
#include <iostream>
using namespace std;


#include <mythtv/mythcontext.h>
#include <mythtv/mythwidgets.h>
#include <mythtv/lcddevice.h>
#include <mythtv/xmlparse.h>

#include "Modulesettings.h"
#include "BrowseWindow.h"
#include "recipe_filter.h"


#define RECIPE  3
#define CUISINE 2
#define COURSE  1


/*
 *
 *
*/
BrowseWindow::BrowseWindow(MythMainWindow *parent, MSqlQuery *ldb, 
	    QString window_name, QString theme_filename, 
            const char *name,
            const char *browse_filename)
           : MythThemedDialog(parent, window_name, theme_filename, name) {

    QString str;

    //  A few internal variable defaults
    if (ldb) {
        db = ldb;
    } else
        db = NULL;

    cout << "BrowseWindow::BrowseWindow() .." << endl;

    // setup volume for music
    //
    volume_control = NULL;
    volume_control = new VolumeControl(true);
    if (volume_control) {
        cout << "\tvolume control is available..."
             << endl;
    } else {
        cout << "\tvolume control is not available..."
             << endl;
    }
    showVolume(true);

    theme=NULL;

    wireUpTheme();

}


/*
 *
 *
*/
BrowseWindow::~BrowseWindow(void) {

    cout << " BrowseWindow::~BrowseWindow(void)... closing..." << endl; 
}



    

/*
 * handle keys/button sent to us...
*/
void BrowseWindow::keyPressEvent(QKeyEvent *e) {
    bool handled = false;
    QStringList actions;
    gContext->GetMainWindow()->TranslateKeyPress("Recipe", e, actions);

    cout << "BrowseWindow::keyPressEvent...\n" << endl;

    for (unsigned int i = 0; i < actions.size() && !handled; i++) {
        QString action = actions[i];
        handled = true;

	cout <<"\t\t"<<action.data() << endl;

        if (action == "SELECT") {
	    enterPressed();
	}
        else if (action == "MENU" || action == "INFO") {}
        else if (action == "UP")
	    cursorUp();
        else if (action == "DOWN")
	    cursorDown();
        else if (action == "LEFT")
            goLeft();
        else if (action == "RIGHT")
            goRight();
        else if (action == "PAGEUP") {}
        else if (action == "PAGEDOWN") {}
        else if (action == "TOGGLEFAV") {}
        else if (action == "MUTE") { 
	    if (muted) {
                if (volume_control)
	           volume_control->SetMute(FALSE);
	    } else {
                if (volume_control)
	           volume_control->SetMute(TRUE);
	    }
        }
        else if (action == "VOLUMEDOWN") {
            if (volume_control)
                volume_control->AdjustCurrentVolume(-1);
        }
        else if (action == "VOLUMEUP") {
            if (volume_control)
                volume_control->AdjustCurrentVolume(1);
        }
        else
            handled = false;
    }

    if (!handled)
        MythThemedDialog::keyPressEvent(e);
    
    updateForeground();
}




/*
 *
 *
*/
void BrowseWindow::goRight() {
    QString str="";
    cout <<"BrowseWindow::goRight()... column(" << ")" << endl;
}


/*
 *
 *
*/
void BrowseWindow::goLeft() {
    cout <<"BrowseWindow::goLeft()... column (" <<") " << endl;

}


/*
 *
 *
*/
void BrowseWindow::numberPressAction(int ) {

}


/*
 *
 *
*/
void BrowseWindow::cursorPgUp() {

}


/*
 *
 *
*/
void BrowseWindow::cursorUp() {
    cout << "BrowseWindow::cursorUp()... column (" << ")" << endl; 
}



/*
 *
 *
*/
void BrowseWindow::cursorPgDown() {

}


/*
 *
 *
*/
void BrowseWindow::cursorDown() {
    cout << "BrowseWindow::cursorDown()... column (" << ")" << endl; 
}


/*
 *
 *
*/
void BrowseWindow::enterPressed() {
    cout << "BrowseWindow::enterPressed()... column (" << ")" << endl; 

}



/*
 *
 *
*/
void BrowseWindow::showVolume(bool /* on_or_off */) {

}



/*
 *
 *
*/
void BrowseWindow::closeEvent(QCloseEvent *event) {
   // check if you need ambient music while you run other modules...
   //
   
   // if (need_ambient) {
   //     leave alone
   // } else {
   //     fmradio->();
   //     or 
   //     exec(mpg123 some.url)
   // }

    hide();
    event->accept();
}



/*
 *
 *
*/
void BrowseWindow::showEvent(QShowEvent *event) {
    QWidget::showEvent(event);
}



/*
 *
 *
*/
void BrowseWindow::customEvent(QCustomEvent *event) {
    QWidget::customEvent(event);
}


/*
 *
 *
*/
void BrowseWindow::wireUpTheme() {
    QString str;


}
