#ifndef MODULE_BROWSE_FILE_H
#define MODULE_BROWSE_FILE_H
/*
 * derived from mythgame
*/

#include <qtimer.h>
#include <qmutex.h>
#include <qvaluevector.h>
#include <qprocess.h>
#include <qfile.h>

#include <qsqldatabase.h>
#include <mythtv/mythdbcon.h>
#include <mythtv/mythwidgets.h>
#include <mythtv/dialogbox.h>
#include <mythtv/volumecontrol.h>
#include <mythtv/xmlparse.h>
#include <mythtv/uilistbtntype.h>




class BrowseWindow : public MythThemedDialog
{
    Q_OBJECT

  public:

    //
    // Now featuring a themed constructor ... YAH!!!
    //
    typedef QValueVector<int> IntVector;
    
    BrowseWindow(MythMainWindow *parent, MSqlQuery *db, 
		    QString window_name, QString theme_filename, 
                    const char *name=0,
                    const char *filename=0);
    ~BrowseWindow(void);

    void keyPressEvent(QKeyEvent *e);
    void updateStatus();
    int  nodeType(GenericTree *node); 

  public slots:
    // player process....
    void readFromPlayerStdout();
    void player_process_done();
    void showVolume(bool /* on_or_off */);
    void stop();
    void record();

    void goRight();
    void goLeft();
    void numberPressAction(int );
    void cursorPgUp();
    void cursorUp();
    void cursorPgDown();
    void cursorDown();
    void enterPressed();
    void closeEvent(QCloseEvent *event);
    void showEvent(QShowEvent *event);
    void customEvent(QCustomEvent *event);
    
  signals:
  
    void dummy();   // debugging

  private:

    // player process variables... ----
    QString      playfile;
    QProcess    *player_process;
    QString      player_output;
    QFile        *player_output_file;
    QTextStream  *player_output_stream;

    QByteArray    player_output_buffer;
    bool          mute;
    // --------------------------------

    QString statusString;
    int directions_cnt, directions_top;
    QStringList cur_directions;

    MSqlQuery *db;

    void wireUpTheme();

    // Metadata *curMeta;

    bool lcd_volume_visible;
    bool muted;
    
    int  widget_focus;

    VolumeControl   *volume_control;

	
    //
    //  Theme-related "widgets"
    //

    XMLParse *recipeTheme;
    XMLParse *theme;
};


#endif
