#include "GetLynxFile.h"
#include <stdlib.h>
#include <iostream>
using namespace std;

/*
 *
 *
*/
bool LynxFile::getUrlFile(QString lynx_file_name, 
                                QString url,
                                bool use_lynx) {
    QString     tmp_lynx_file_name;
    bool   ok=false;
    static int cnt=0;
    QDir    mythdir( PREFIX "/share/mythtv/themes/default/recipes/.");

    cout << "LynxFile::getUrlFile() "  << endl
         << "\t usr is " << url.data() << endl
         << "\t tmp file is " << lynx_file_name.data() 
         << endl;

    if (use_lynx) {
        tmp_lynx_file_name = lynx_file_name;
    } else {
        tmp_lynx_file_name.sprintf("/tmp/mythRecipe/tmp_lynx_file_name.%i",cnt);
    }

/*
    QProcess p(this, "lynx process");
    
                    if (use_lynx) {
                        p.addArgument( "lynx.sh" );
                        p.addArgument( tmp_lynx_file_name );
                        p.addArgument( "-crawl" );
                        p.addArgument( "-dont_wrap_pre" );
                        p.addArgument( "-force_empty_hrefless_a" );
                        p.addArgument( "-image_links" );
                        p.addArgument( "-nobold" );
                        p.addArgument( "-nocolor" );
                        p.addArgument( "-noreverse" );
                        p.addArgument( "-nounderline" );
                        p.addArgument( "-number_links" );
                        p.addArgument( "-width 1024" );
                        p.addArgument( "-dump" );
                        p.addArgument( url );
                    } else {
                        p.addArgument( "wget" );
                        p.addArgument( "-a"   );
                        p.addArgument( "/tmp/wget.log" );
                        p.addArgument( "-nd" );
                        p.addArgument( "-nH" );
                        p.addArgument( url );
                    }
                    
                    if ( !p.start() ) {
                        cout <<"\t GetLynxFile.cpp::LynxFile::getUrlFile:   error executing lynx... !? check lynx install"<<endl;
                        // return false;
                        ok = false;
                    } else {
		        while (p.isRunning()) { }
                        ok = true;
                    }
*/
    lynx_proc = new QProcess(this);
    if (lynx_proc)  {
        lynx_proc->setWorkingDirectory( mythdir );
        lynx_output_file = new QFile(tmp_lynx_file_name);
        if (lynx_output_file) {
            lynx_output_stream = new QTextStream(lynx_output_file);
            if (lynx_output_stream) {
	        if (lynx_output_file->open( IO_WriteOnly )) {
                    if (use_lynx) {
                        lynx_proc->addArgument( "lynx" );
                        lynx_proc->addArgument( "-crawl" );
                        lynx_proc->addArgument( "-dont_wrap_pre" );
                        lynx_proc->addArgument( "-force_empty_hrefless_a" );
                        lynx_proc->addArgument( "-image_links" );
                        lynx_proc->addArgument( "-nobold" );
                        lynx_proc->addArgument( "-nocolor" );
                        lynx_proc->addArgument( "-noreverse" );
                        lynx_proc->addArgument( "-nounderline" );
                        lynx_proc->addArgument( "-number_links" );
                        lynx_proc->addArgument( "-width 1024" );
                        lynx_proc->addArgument( "-dump" );
                        lynx_proc->addArgument( url );
                    } else {
                        lynx_proc->addArgument( "wget" );
                        lynx_proc->addArgument( "-a"   );
                        lynx_proc->addArgument( "/tmp/wget.log" );
                        lynx_proc->addArgument( "-nd" );
                        lynx_proc->addArgument( "-nH" );
                        lynx_proc->addArgument( url );
                    }
                    connect( lynx_proc, SIGNAL(readyReadStdout()),
	                 this, SLOT(readFromStdout()) );
                    connect( lynx_proc, SIGNAL(processExited()),
    	                 this, SLOT(lynx_process_done()) );


                    // debug
                    QStringList arg_list = lynx_proc->arguments();
                    QString args_string= arg_list.join(" ");
                    cout << " lynx_proc args =" << args_string << endl;

                    if ( !lynx_proc->start() ) {
                        cout <<"\terror executing lynx... !?"<<endl;
                        // return false;
                    } else {
                        cout <<"Started lynx Waiting for exit....." << endl;
			sleep(1);

                        int timeout_count=0;
                        while (lynx_proc->isRunning()) 
                        {
                           usleep(10000); // 10ms
                           timeout_count++; 
                           if (timeout_count > 2000) // 20 sec timeout
                           {
                                cout << "killing lynx_proc.. NOTE: use lynx 2.8.5.   2.8.6 is broke " << endl;
                                lynx_proc->kill();
                                disconnect( lynx_proc, SIGNAL(readyReadStdout()),
                                      this, SLOT(readFromStdout()) );
                                disconnect( lynx_proc, SIGNAL(processExited()),
                                      this, SLOT(lynx_process_done()) );
                               return false;
                           }
                        }
			cout <<"lynx finished....." << endl;
                        disconnect( lynx_proc, SIGNAL(readyReadStdout()),
	                     this, SLOT(readFromStdout()) );
                        disconnect( lynx_proc, SIGNAL(processExited()),
    	                     this, SLOT(lynx_process_done()) );
                        ok = true;
                    }

                } else {
		    cout << "\t  GetLynxFile.cpp::LynxFile::getUrlFile can't open output file =" << tmp_lynx_file_name << endl;
                }
		// cout << "\tdeleting lynx_output_stream..." << endl;
                delete lynx_output_stream;
            } else {
	        cout << "\toutput stream not available..." << endl; 
	    }
            // cout << "\tdeleting lynx_output_file..." << endl;
            delete lynx_output_file;
        } else {
	    cout << "\toutput file not available..." << endl;
        }
        // cout << "\tdeleting lynx_proc..." << endl;
        delete lynx_proc;
    } else {
        cout << "\tno process available..." << endl;
    }

    return ok;
}




/*
 *
 *
*/
void LynxFile::readFromStdout() {

    if (lynx_output_stream) {
        (*lynx_output_stream) << ( (QCString )lynx_proc->readStdout());
    }
}


/*
 *
 *
*/
void LynxFile::lynx_process_done() {

/*
    cout << "ScanSiteWindow::lynx_process_done() ... "
	 << "finish data from lynx output... "
	 << endl;
*/
}

