#ifndef RECIPE_DATABASE_H
#define RECIPE_DATABASE_H

#include <qsqldatabase.h>
#include <mythtv/mythdbcon.h>
#include <mythtv/mythwidgets.h>
#include <mythtv/dialogbox.h>
#include <qprocess.h>
#include <qxml.h>
#include <qregexp.h>

#include "menu.h"

#ifndef DEBUG
#define myqDebug(a)  
#else
#define myqDebug(a) qDebug(a);
#endif




class RecipeDB : public QObject
{
    Q_OBJECT

  public:

    RecipeDB(QObject *parent=0, const char *name=0, MSqlQuery *db=0); 

    ~RecipeDB(void);

  public slots:

    int addRecipeToDatabase( Recipe &recipe );

    int addRecipeToDatabase( Menu &menu );

  private slots:

    int getRecipeId( QString &);
    QString getAuthorName( int id );
    int getAuthorId( QString &, bool addifnotexist=true );
    int getUnitId( QString &, bool addifnotexist=true );
    int addRecipe( Header &recipehead );
    int addRecipeToCourse( int recipeid, int courseid );
    int addCourse( QString &coursename, int parent=0 );
    int getCourseId( QString coursename, int parent=0 );
    int addIngredients( int recipeid, Ingredient &ingredients );
    int addInstructionLine( int recipeid, int linenumber, QString &step);

  private:

    MSqlQuery *db;

};

#endif

