/*
 * derived from mythgame
*/
#include <mythtv/mythcontext.h>

#include "Modulesettings.h"
#include <qfile.h>
#include <qdialog.h>
#include <qcursor.h>
#include <qdir.h>
#include <qimage.h>

// General Settings

class RecipeShowFavourites: public CheckBoxSetting, public GlobalSetting {
public:
   RecipeShowFavourites():
        GlobalSetting("ModuleShowFavourites") {
        setLabel(QObject::tr("Show Only Favourites"));
        setValue(false);
        setHelpText(QObject::tr("Limit Recipes listed to only those tagged "
                    "as \"favourite\""));
    };
};

class RecipeLoadLocation: public LineEditSetting, public GlobalSetting {
public:
        RecipeLoadLocation():
        GlobalSetting("RecipeLoadLocation") {
        setLabel(QObject::tr("Path to Recipe Files"));
        setValue(PREFIX "/share/mythRecipe/loadfiles");
        setHelpText(QObject::tr("Directory where Recipes in RecipeML and mythRecipeURL forms/files are kept."));
    };
};

RecipeModuleSettings::RecipeModuleSettings() {
    VerticalConfigurationGroup *general = new VerticalConfigurationGroup(false);
    general->setLabel(QObject::tr("MythRecipe Settings -- General"));
    general->addChild(new RecipeShowFavourites());
    general->addChild(new RecipeLoadLocation());
    addChild(general);
}

