#ifndef SCANSITESWINDOW_H
#define SCANSITESWINDOW_H

#include <qsqldatabase.h>
#include <mythtv/mythdbcon.h>
#include <mythtv/mythwidgets.h>
#include <mythtv/dialogbox.h>
#include <qprocess.h>
#include <qxml.h>
#include <qregexp.h>
#include <qcstring.h>

#ifndef DEBUG
#define myqDebug(a)  
#else
#define myqDebug(a) qDebug(a);
#endif




class ScanSiteWindow : public MythThemedDialog
{
    Q_OBJECT

  public:

    ScanSiteWindow(MythMainWindow *parent, MSqlQuery *db, 
	   QString window_name, QString theme_filename, const char *name=0);

    ~ScanSiteWindow(void);

    void keyPressEvent(QKeyEvent *e);

  public slots:
    bool processRecipePage( QString &lynx_file_name,
                            // QStringList &rec_info,
                            QString     &serving,
                            QString     &comment,
                            QString     &extra_comment,
                            QString     &recipe_image,
                            QStringList &ingredients,
                            QStringList &directions,
                            QStringList &extra,          // add info
                            QStringList &links);         // extra urls

    void addRecipeToDatabase( QStringList &reclist,
                              QString     &course,
                              QString     &serving,
                              QString     &comment,
                              QString     &extra_comment,
                              QString     &recipe_img_name,
                              QByteArray  &recipe_image,
                              QStringList &ingredients,
                              QStringList &directions);

    bool processCoursePage( QString &course_file_name,
                            QString &course,
		            QStringList &, QStringList &,
			    int & current_page, int &total_page );

    bool getUrlFile(QString tmpfile, QString url, bool use_lynx=true);

    QStringList decipherIngredients( QString );

    void scanSites();

  private slots:
    void wireUpTheme();
    void enterPressed();
    void readFromStdout();
    void lynx_process_done();

    QString nextLine( QFile * ); 
    QString nextLine( QFile *, QRegExp );
    QString nextLine( QFile *, QRegExp rx, QString &lastline );
    void    scanCourseRecipe(QFile *, QString, QString, QStringList &);

    void scan_cooking_com();

  private:

    MSqlQuery *db;

    int recipes_at_atime;

    /*
    QProcess     *proc, *lynx_proc;
    QString      lynx_output;
    QFile        *lynx_output_file;
    QTextStream  *lynx_output_stream;

    QByteArray   lynx_output_buffer;
    */

    // UIBarType    *page1_status;
    // UIBarType    *page2_status;
    // UIBarType    *page3_status;

    MythProgressDialog *pd0; 
    MythProgressDialog *pd1; 
    MythProgressDialog *pd2; 

    MythMainWindow     *parent;
};

#endif
