#ifndef SCANXMLWINDOW_H
#define SCANXMLWINDOW_H

#include <qsqldatabase.h>
#include <mythtv/mythdbcon.h>
#include <mythtv/mythwidgets.h>
#include <mythtv/dialogbox.h>
#include <qprocess.h>
#include <qxml.h>
#include <qregexp.h>

#include "RecipeDB.h"

#ifndef DEBUG
#define myqDebug(a)  
#else
#define myqDebug(a) qDebug(a);
#endif




class ScanXML : public MythThemedDialog
{
    Q_OBJECT

  public:

    ScanXML(MythMainWindow *parent, MSqlQuery *db, 
	   QString window_name, QString theme_filename, const char *name=0);

    ~ScanXML(void);

    void keyPressEvent(QKeyEvent *e);
    void importXML( QString &filepath );

  public slots:

    int addRecipeToDatabase( Recipe &recipe );

    int addRecipeToDatabase( Menu &menu );

    void scanXML();

  private slots:
    void wireUpTheme();
    void enterPressed();

    int getRecipeId( QString &);
    QString getAuthorName( int id );
    int getAuthorId( QString &, bool addifnotexist=true );
    int getUnitId( QString &, bool addifnotexist=true );
    int addRecipe( Header &recipehead );
    int addRecipeToCourse( int recipeid, int courseid );
    int addCourse( QString &coursename, int parent=0 );
    int getCourseId( QString coursename, int parent=0 );
    int addIngredients( int recipeid, Ingredient &ingredients );
    int addInstructionLine( int recipeid, int linenumber, QString &step);

  private:

    MSqlQuery    *db;
    RecipeDB     *recipedb;


    // UIBarType    *page1_status;
    // UIBarType    *page2_status;
    // UIBarType    *page3_status;

    MythProgressDialog *pd0; 
    MythProgressDialog *pd1; 
    MythProgressDialog *pd2; 
};

#endif

