#ifndef VIEW_RECIPE_WINDOW_H
#define VIEW_RECIPE_WINDOW_H
/*
 * derived from mythgame
*/

#include <qtimer.h>
#include <qmutex.h>
#include <qvaluevector.h>
#include <qprocess.h>
#include <qfile.h>

#include <qsqldatabase.h>
#include <mythtv/mythdbcon.h>
#include <mythtv/mythwidgets.h>
#include <mythtv/dialogbox.h>
#include <mythtv/volumecontrol.h>
#include <mythtv/xmlparse.h>
#include <mythtv/uilistbtntype.h>




class ViewRecipeWindow : public MythThemedDialog
{
    Q_OBJECT

  public:

    //
    // Now featuring a themed constructor ... YAH!!!
    //
    
    ViewRecipeWindow(MythMainWindow *parent, MSqlQuery *db, 
		    QString window_name, QString theme_filename, 
                    const char *name=0,
                    const char *recipen_name=0);
    ~ViewRecipeWindow(void);

    void keyPressEvent(QKeyEvent *e);
    void displayRecipe( QString recipename);

  public slots:
    // player process....
    void showVolume(bool /* on_or_off */);

    void goRight();
    void goLeft();
    void numberPressAction(int );
    void cursorPgUp();
    void cursorUp();
    void cursorPgDown();
    void cursorDown();
    void enterPressed();

  private slots:
    // widgets focus events...
    void ingredients_list_enter_focus();
    void directions_list_enter_focus();
    void ingredients_list_loose_focus();
    void directions_list_loose_focus();

  signals:
  
    void dummy();   // debugging

  private:
    int m_InColumn;

    // --------------------------------

    QString statusString;

    MSqlQuery *db;

    void wireUpTheme();

    // Metadata *curMeta;

    bool lcd_volume_visible;
    bool muted;
    
    int  widget_focus;

    VolumeControl   *volume_control;

	
    //
    //  Theme-related "widgets"
    //

    XMLParse *recipeTheme;
    XMLParse *theme;

    UIListBtnType         *ingredients_list;
    UIListBtnType         *directions_list;
    
    UIImageType           *recipe_image;
    UIImageType           *info0_image;
    UIImageType           *info1_image;
    UIImageType           *info2_image;
    UIImageType           *info3_image;
    UIImageType           *info4_image;
    
    UITextType            *author_text;
    UITextType            *source_text;
    UITextType            *serving_text;
    UITextType            *comment_text;
    UITextType            *current_recipe_text;
    
    UIStatusBarType       *volume_status;
    UIPushButtonType      *mute_button;
};


#endif
