#include <qdir.h>
#include <iostream>
using namespace std;

#include <qapplication.h>
#include <qsqldatabase.h>
#include <unistd.h>

#include "Modulesettings.h"
#include "ModuleWindow.h"
#include "ScanSiteWindow.h"
#include "BrowseWindow.h"
#include "ScanXML.h"

#include <mythtv/libmythui/myththemedmenu.h>
#include <mythtv/mythcontext.h>
#include <mythtv/mythdbcon.h>
#include <mythtv/lcddevice.h>


struct ModuleData
{
    MSqlQuery *db;
};


void runModule(void);
void runImportRecipeML(void);
void runBrowseFavouriteRecipes(void);
void runEditRecipe(void);
void runScanRecipeSites(void);
void runBrowseRecipes(void);
void runBrowseMenus(void);
void runPurgeSetupRecipe( void );
void runRecipeSettings( void );
void runRecipeMusicSettings( void );
void runResetRecipeDefaults( void );

void runRecipeSetupDatabase();


/*
void runBrowseRecipes0(void);
void runBrowseRecipes1(void);
*/

void ModuleCallback(void *data, QString &selection)
{
    //ModuleData *ddata = (ModuleData *)data;
    QString sel = selection.lower();
    
    //(void)ddata;

	MSqlQuery query(MSqlQuery::InitCon());
    if (sel == "recipe_settings") {
        runRecipeSettings();
    } else if (sel == "recipe_music_settings") {
        runRecipeMusicSettings();
    } else if (sel == "purge_setup_recipe_tables") {
	    runPurgeSetupRecipe( );
    } else if (sel == "reset_recipe_defaults") {
	    runResetRecipeDefaults( );
    } else if (sel == "import_recipe_ml") {
        // ModuleHandler::processAllModule();
	// runImportRecipeML();

	
        ScanXML modulewindow(gContext->GetMainWindow(), 
			                 &query,
	                         "Recipe", 
	                         "Recipe-scan-site-", 
                             "Recipe");
        modulewindow.show();
	
    } else if (sel == "browse_favourite_recipes") {
        // ModuleHandler::processAllModule();
	runBrowseFavouriteRecipes();
    } else if (sel == "edit_recipe") {
        // ModuleHandler::processAllModule();
	runEditRecipe();
    } else if (sel == "scan_recipe_sites") {
        // ModuleHandler::processAllModule();
	// runScanRecipeSites();
	
        ScanSiteWindow modulewindow(gContext->GetMainWindow(), 
			                       &query,
	                                "Recipe", 
	                                "Recipe-scan-site-", 
                                    "Recipe");
        modulewindow.show();
	
    } else if (sel == "browse_menus") {
        // ModuleHandler::processAllModule();
	runBrowseMenus();
    } else if (sel == "browse_recipes") {
        // ModuleHandler::processAllModule();
        
        ModuleWindow modulewindow(gContext->GetMainWindow(), 
			                      &query,
	                              "Recipe", 
                                  "Recipe-",
                                  "Recipe");
        modulewindow.exec();

    } else if (sel == "browse_recipes-0") {
        // ModuleHandler::processAllModule();
        ModuleWindow modulewindow(gContext->GetMainWindow(), 
			                      &query,
	                              "Recipe", 
                                  "Recipe-new-01-",   // "Recipe-0-",
                                  "Recipe");
        modulewindow.exec();
    } else if (sel == "browse_recipes-1") {
        // ModuleHandler::processAllModule();
        ModuleWindow modulewindow(gContext->GetMainWindow(), 
			                      &query,
	                              "Recipe", 
                                  "Recipe-new-02-",
                                  "Recipe");
        modulewindow.exec();
    } else if (sel == "about_mythrecipe") {
        // ModuleHandler::processAllModule();
        
        BrowseWindow browsewindow(gContext->GetMainWindow(), 
			                      &query,
	                              "Recipe", 
                                  "Recipe-bf-",
                                  "Recipe",
                                  "about.txt");
        browsewindow.exec();

    } else if (sel == "search_url_for_recipe") {
        // ModuleHandler::processAllModule();
    } 
    else if (sel == "exiting_menu") 
    { // when exiting
      
    } else
    MythPopupBox::showOkPopup(gContext->GetMainWindow(),
                                QObject::tr("This module (%1)" 
					              " option is not implemented yet.").arg(sel),
                                QObject::tr("This module (%1)"
					             " option is not implemented yet.").arg(sel));
}


void runMenu(QString which_menu) {

    cout << "Starting MythRecipie runMenu() " << endl;

    QString themedir = gContext->GetThemeDir();
    
//     MythThemedMenu *diag = new MythThemedMenu(themedir.ascii(), which_menu,
//                                       gContext->GetMainWindow(), "Module menu");

    cout << "Starting MythRecipie themedir= "<< themedir << endl;
    MythThemedMenu *diag = new MythThemedMenu(themedir.ascii(), which_menu,
                                     GetMythMainWindow()->GetMainStack(), "Module menu");


    ModuleData data;
    data.db = new MSqlQuery(MSqlQuery::InitCon());
    cout << "in MythRecipie runMenu()  1" << endl;
    diag->setCallback(ModuleCallback, &data);
    diag->setKillable();
    cout << "in MythRecipie runMenu()  2" << endl;
    if (diag->foundTheme()) {
        if (class LCD * lcd = LCD::Get()) {
            lcd->switchToTime();
        }
//         diag->exec();
	cout << "in MythRecipie runMenu() 3 calling GetMythMainWindow()->GetMainStack() " << endl;
        GetMythMainWindow()->GetMainStack()->AddScreen(diag);
	cout << "in MythRecipie runMenu() 4 returning GetMythMainWindow()->GetMainStack() " << endl;
    } else {
        cerr << QString("Couldn't find theme %1").arg(themedir) << endl;
	delete diag;
    }

    
}


extern "C" {
int mythplugin_init(const char *libversion);
int mythplugin_run(void);
int mythplugin_config(void);
}


// 
void setupKeys(void) {
    // 
    // These are the jump points for the plugin
    REG_JUMP("import_recipe_ml", 
	     "Import recipes into myth database from XML format", 
	     "RECIRM", runImportRecipeML);
    REG_JUMP("browse_favourite_recipes", 
	     "Browse favourite recipes", 
	     "RECBFR", runBrowseFavouriteRecipes);
    REG_JUMP("edit_recipe", 
	     "Edit recipe", 
	     "RECEDT", runEditRecipe);
    REG_JUMP("reset_recipe_defaults", 
	     "Reset settings", 
	     "RSTSET", runResetRecipeDefaults);
    REG_JUMP("scan_recipe_sites", 
	     "Scans recipe web sites using predefined scripts", 
	     "RECSRS", runScanRecipeSites);
    REG_JUMP("browse_recipes", 
	     "Browse all Recipes using Tree list", 
	     "RECBRS", runBrowseRecipes);
    REG_JUMP("recipe_settings", 
	     "General Recipe Settings", 
	     "RECSET", runRecipeSettings);
    REG_JUMP("recipe_music_settings", 
	     "Setup mythRecipe Ambient Music option", 
	     "RECMST", runRecipeMusicSettings);
    REG_JUMP("purge_setup_recipe_tables", 
	     "Purge/Setup mythRecipe Tables...", 
	     "RECPRG", runRecipeMusicSettings);


    // These are the keys we want to recognised and use
    // 
    REG_KEY("Recipe", "DELETE",     "Delete track from playlist", "D");
    REG_KEY("Recipe", "NEXT",       "Move to the next track",     ">,.,Z,End");
    REG_KEY("Recipe", "PREV",       "Move to the previous track", ",,<,Q,Home");
    REG_KEY("Recipe", "SEEKNEXT",   "Next Station",               "PgDown");
    REG_KEY("Recipe", "SEEKPREV",   "Prev Station",               "PgUp");
    REG_KEY("Recipe", "VOLUMEDOWN", "Volume down",                "[,{,F10");
    REG_KEY("Recipe", "VOLUMEUP",   "Volume up",                  "],},F11");
    REG_KEY("Recipe", "MUTE",       "Mute",                       "|,\\,F9");
    REG_KEY("Recipe", "SEARCH",     "Search",                     "F7");
    REG_KEY("Recipe", "TOGGLEFAV",  "Favourite",                  "?,/");

    // REG_MEDIA_HANDLER("MythModule Media Handler", "", "", handleMedia, MEDIATYPE_AUDIO | MEDIATYPE_MIXED);

}


int mythplugin_init(const char *libversion) {
    QString recipe_ver;
    if (!gContext->TestPopupVersion("mythRecipe", libversion,
                                    MYTH_BINARY_VERSION))
        return -1;

    MythModuleSettings settings;
    
    settings.load();
    settings.save();

    setupKeys();

    recipe_ver = gContext->GetSetting("RecipeVersion", "0.0.0" );
    if (recipe_ver=="0.0.0") {
        cout << "mythRecipe::.. seting up initial database/tables..." << endl;
        runRecipeSetupDatabase();
        cout << "mythRecipe::... set version number to " 
             << MYTHRECIPEVERSION << " ..." << endl;
        gContext->SaveSetting("RecipeVersion", MYTHRECIPEVERSION );
        cout << "mythRecipe::...Done.. " << endl;
    } 
    
    return 0;
}


void runModule(void)
{
    QTranslator translator( 0 );
    translator.load(PREFIX + QString("/share/mythtv/i18n/mythRecipe_") +
                    QString(gContext->GetSetting("Language").lower()) +
                    QString(".qm"), ".");
    qApp->installTranslator(&translator);

    MSqlQuery *db = new MSqlQuery(MSqlQuery::InitCon());

    cout << "main.cpp:runModule:...  running your Module Program here.......\n"; 

    QString paths = gContext->GetSetting("Recipe");

    gContext->addCurrentLocation("mythRecipe"); // karl

    ModuleWindow modulewindow(gContext->GetMainWindow(), db,
		                                         "Recipe", 
		                                         "Recipe-",
		                                         "Recipe");
    modulewindow.exec();


    qApp->removeTranslator(&translator);
}


int mythplugin_run(void) {
    // runModule();

    cout << " in mythplugin_run for recipe " << endl;
    runMenu("Recipemain-ui.xml");

    return 0;
}


int mythplugin_config(void) {
    QTranslator translator( 0 );
    translator.load(PREFIX + QString("/share/mythtv/i18n/mythRecipe_") +
                    QString(gContext->GetSetting("Language").lower()) +
                    QString(".qm"), ".");
    qApp->installTranslator(&translator);

    runMenu("Recipe-settings.xml");

    qApp->removeTranslator(&translator);
    return 0;
}


/*
 *
 *
*/
void runResetRecipeDefaults( void ) {
        // MythModuleSettings settings;
        // settings.exec();
        
        // gContext->SaveSetting("RecipeVersion", MYTHRECIPEVERSION );
}


/*
 *
 *
*/
void runRecipeSettings( void ) {
        MythModuleSettings settings;
        settings.exec();
}



/*
 *
 *
*/
void runRecipeMusicSettings( void ) {
        RecipeMusicSettings settings;
        settings.exec();
}


/*
 *
 *
*/
void runImportRecipeML(void) {

    MythPopupBox::showOkPopup(gContext->GetMainWindow(),
                  QObject::tr("This module option is not implemented yet.")\
                             +"runImportRecipeML",
                  QObject::tr("This module option will be implemented soon... ")\
                             +"runImportRecipeML");
}



/*
 *
 *
*/
void runBrowseFavouriteRecipes(void) {

    MythPopupBox::showOkPopup(gContext->GetMainWindow(),
              QObject::tr("This module option is not implemented yet.")\
                         +"runBrowseFavouriteRecipes",
              QObject::tr("This module option will be implemented soon... ")\
                         +"runBrowseFavouriteRecipes");
}



/*
 *
 *
*/
void runEditRecipe(void) {

    MythPopupBox::showOkPopup(gContext->GetMainWindow(),
                   QObject::tr("This module option is not implemented yet.")\
                              +"runEditRecipe",
                   QObject::tr("This module option will be implemented soon...")\
                              +"runEditRecipe");
}



/*
 *
 *
*/
void runScanRecipeSites(void) {

    MSqlQuery *db = new MSqlQuery(MSqlQuery::InitCon());

        ScanSiteWindow modulewindow(gContext->GetMainWindow(), 
			                   db,
                               "Recipe", 
                               "Recipe-scan-site-", 
                               "Recipe");
        modulewindow.show();
	/*

    MythProgressDialog *pd0 = new MythProgressDialog(
		         "Scanning site www.cooking.com for recipes....", 100);
    pd0->move(1,1);

    MythProgressDialog *pd1 = new MythProgressDialog(
		         "Scanning page ( xxx of xxx ) ...", 100);
    pd1->move(150,150);

    MythPopupBox::showOkPopup(gContext->GetMainWindow(),
                                QObject::tr("This module option is not implemented yet."),
                                QObject::tr("This module option will be implemented soon... "));
    pd1->close();
    pd0->close();
    */
}



/*
 *
 *
*/
void runBrowseRecipes(void) {


    MythPopupBox::showOkPopup(gContext->GetMainWindow(),
                    QObject::tr("This module option is not implemented yet.")\
                               +"runBrowseRecipes",
               QObject::tr("This module option will be implemented soon... ")\
                          +"runBrowseRecipes");
}



/*
 *
 *
*/
void runBrowseMenus(void) {


    MythPopupBox::showOkPopup(gContext->GetMainWindow(),
                    QObject::tr("This module option is not implemented yet.")\
                               +"runBrowseMenus",
               QObject::tr("This module option will be implemented soon... ")\
                          +"runBrowseMenus");
}



/*
 *
 *
*/
void runPurgeSetupRecipe( void ) {
    if ( MythPopupBox::showOkCancelPopup(gContext->GetMainWindow(),
         QObject::tr("database purged and setup ok."),
         QObject::tr("are you sure you want to remove all recipes from "
		    "the database?\n\tdatabase purged and setup ok... "), true )){
        runRecipeSetupDatabase();
    } 
    /*
        MythPopupBox::showOkPopup(gContext->GetMainWindow(),
            QObject::tr("database purged and setup ok."),
            QObject::tr("database purged and setup ok... "));
    */
}




/*
 *
 *
*/
// void setupDatabase( ) {
void runRecipeSetupDatabase() {
int cnt=0;
QString thequery="";

    MSqlQuery query(MSqlQuery::InitCon());


static QString dbquery[] = {
                  "DROP TABLE categories; ",
                  "DROP TABLE category_entries; ",
                  "DROP TABLE ingredient_types; ",
                  "DROP TABLE ingredients; ",
                  "DROP TABLE instructions; ",
                  "DROP TABLE recipes; ",
                  "DROP TABLE units; ",
                  "DROP TABLE user_access_grants; ",
                  "DROP TABLE user_permissions; ",
                  "DROP TABLE user_recipe_bookmarks; ",
                  "DROP TABLE users; ",
                  "DROP TABLE login_log; " ,
                  "DROP TABLE related_recipes ; ",

"CREATE TABLE IF NOT EXISTS categories ( "
"	category_id 		INT4			NOT NULL AUTO_INCREMENT," 
"	parent 				INT4 			NOT NULL," 
"	name 				TEXT			NOT NULL," 
"	CONSTRAINT 			pk_categories PRIMARY KEY (category_id)" 
");", 


"CREATE TABLE  IF NOT EXISTS category_entries ( "
"	recipe_id 			INT4 			NOT NULL, "
"	category_id			INT4 			NOT NULL, "
"	CONSTRAINT			pk_category_entries PRIMARY KEY (recipe_id, category_id) "
"); ",


"CREATE TABLE IF NOT EXISTS ingredient_types ( "
"	ingredient_type		INT4			NOT NULL AUTO_INCREMENT, "
"	name 				VARCHAR(100) 	NOT NULL, "
"	info 				VARCHAR(100), "
"	CONSTRAINT 			pk_ingredient_types PRIMARY KEY (ingredient_type) "
"); ",


"CREATE TABLE IF NOT EXISTS ingredients ( "
"	ingredient_id 		INT4			NOT NULL AUTO_INCREMENT, "
"	recipe_id 			INT4 			NOT NULL, "
"	display_order 		INT4			, "
"	ingredient_type 	INT4 			NOT NULL, "
"	sub_recipe_id 		INT4			, "
"	name 				VARCHAR(100) 	NOT NULL, "
"	qty					DECIMAL(10,5)	NOT NULL, "
"	unit_id 			INT4 			NOT NULL, "
"	CONSTRAINT 			pk_ingredients PRIMARY KEY (ingredient_id), "
"	INDEX				indx_ingredients_recipe_id (recipe_id) "
"); ",


"CREATE TABLE IF NOT EXISTS instructions ( "
"	recipe_id 			INT4 			NOT NULL, "
"	step_num 			INT4 			NOT NULL, "
"	step_text 			TEXT			, "
"	INDEX 				indx_instructions_recipe_id (recipe_id) "
"); ",


"CREATE TABLE IF NOT EXISTS recipes ( "
"	recipe_id 			INT4			NOT NULL AUTO_INCREMENT, "
"	name 				TEXT		 	NOT NULL, "
"	yield_qty 			INT2			, "
"	yield_units 		TEXT			, "
"	source 				TEXT		    NOT NULL, "
"	create_utime 		VARCHAR(32)     NOT NULL, "
"	mod_utime 			VARCHAR(32)     NOT NULL, "
"	author_user_id 		INT4			NOT NULL, "
"   favourite           BOOL, "
"   comment             TEXT, "
"   extra_comment       TEXT, "
"   image_name          VARCHAR(32), "
"   recipe_image        BLOB, "
"	CONSTRAINT 			pk_recipes PRIMARY KEY (recipe_id) "
"); ",


"CREATE TABLE IF NOT EXISTS units ( "
"	unit_id 			INT4			NOT NULL AUTO_INCREMENT, "
"	name 				VARCHAR(100) 	NOT NULL, "
"	abbreviation 		VARCHAR(10) 	NOT NULL, "
"	CONSTRAINT 			pk_units PRIMARY KEY (unit_id) "
"); ",


"CREATE TABLE IF NOT EXISTS user_access_grants ( "
"	user_id 			INT4 			NOT NULL, "
"	permission_id 		INT2 			NOT NULL, "
"	granter_user_id 	INT4 			NOT NULL, "
"	grant_utime 		VARCHAR(20) 	NOT NULL, "
"	INDEX 				indx_user_access_grants_uid (user_id) "
"); ",


"CREATE TABLE IF NOT EXISTS user_permissions ( "
"	permission_id 		INT2 			NOT NULL, "
"	short_description 	VARCHAR(100) 	NOT NULL, "
"	long_description 	TEXT			, "
"	CONSTRAINT 			pk_user_permissions PRIMARY KEY (permission_id) "
"); ",


"CREATE TABLE IF NOT EXISTS user_recipe_bookmarks ( "
"	user_id 			INT4 			NOT NULL, "
"	recipe_id 			INT4 			NOT NULL, "
"	url                      	VARCHAR(100), "
"	CONSTRAINT 			pk_user_recipe_bookmarks PRIMARY KEY (user_id, recipe_id) "
"); ",


"CREATE TABLE IF NOT EXISTS users ( "
"	user_id 			INT4			NOT NULL 		AUTO_INCREMENT, "
"	user_name 			VARCHAR(30) 	NOT NULL, "
"	user_name_lower 	VARCHAR(30) 	NOT NULL, "
"	password 			VARCHAR(40) 	NOT NULL, "
"	email 				VARCHAR(75) 	NOT NULL, "
"	url 				VARCHAR(100)	, "
"	status 				INT2 			DEFAULT 1 		NOT NULL, "
"	email_private 		INT2			, "
"	create_utime 		VARCHAR(20)		NOT NULL, "
"	CONSTRAINT 			pk_users PRIMARY KEY (user_id), "
"	CONSTRAINT 			indx_unq_users_user_name_lower UNIQUE (user_name_lower) "
"); ",


"CREATE TABLE IF NOT EXISTS login_log ( "
"	user_id				INT4			NOT NULL, "
"	ip					VARCHAR(16)		, "
"	hostname			VARCHAR(255)	, "
"	login_utime			VARCHAR(20)		NOT NULL, "
"	INDEX 				indx_login_log_user_id (user_id) "
"); ",

"CREATE TABLE IF NOT EXISTS related_recipes ( "
"	recipe_id 			INT4 			NOT NULL, "
"	related_id			INT4 			NOT NULL, "
"	CONSTRAINT			pk_category_entries PRIMARY KEY (recipe_id, related_id) "
"); ",

"INSERT INTO units (name, abbreviation) VALUES ('Teaspoons', 		'tsp'); ",
"INSERT INTO units (name, abbreviation) VALUES ('Tablespoons', 		'tbsp'); ",
"INSERT INTO units (name, abbreviation) VALUES ('Cups', 		'cps'); ",
"INSERT INTO units (name, abbreviation) VALUES ('Cans', 		'can'); ",
"INSERT INTO units (name, abbreviation) VALUES ('Pints', 		'pt'); ",
"INSERT INTO units (name, abbreviation) VALUES ('Quarts', 		'qt'); ",
"INSERT INTO units (name, abbreviation) VALUES ('Gallons', 		'gal'); ",
"INSERT INTO units (name, abbreviation) VALUES ('Mililiters', 	        'ml'); ",
"INSERT INTO units (name, abbreviation) VALUES ('Liters', 		'l'); ",
"INSERT INTO units (name, abbreviation) VALUES ('Ounces', 		'oz'); ",
"INSERT INTO units (name, abbreviation) VALUES ('Fluid ounces', 	'Fl oz'); ",
"INSERT INTO units (name, abbreviation) VALUES ('Grams', 		'g'); ",
"INSERT INTO units (name, abbreviation) VALUES ('Kilograms', 	        'kg'); ",
"INSERT INTO units (name, abbreviation) VALUES ('Pinches', 		'pinches'); ",
"INSERT INTO units (name, abbreviation) VALUES ('Each', 		'ea'); ",
"INSERT INTO units (name, abbreviation) VALUES ('Pounds', 		'lb'); ",


"INSERT INTO ingredient_types (ingredient_type, name) VALUES (1, 'Normal'); ",
"INSERT INTO ingredient_types (ingredient_type, name) VALUES (2, 'Sub-heading'); ",
"INSERT INTO ingredient_types (ingredient_type, name) VALUES (3, 'Divider'); ",
"INSERT INTO ingredient_types (ingredient_type, name) VALUES (4, 'Recipe Link'); ",


"INSERT INTO user_permissions (permission_id, short_description, long_description) VALUES (0, 'All Access',        'User may do anything possible in the system (root access). If a user has All Access permission, is is not necessary to grant them anything else.'); ",
"INSERT INTO user_permissions (permission_id, short_description, long_description) VALUES (1, 'Delete Any Recipe', 'User may delete any recipe in the system.'); ",
"INSERT INTO user_permissions (permission_id, short_description, long_description) VALUES (2, 'Edit Any Recipe',   'User may make changes to any recipe in the system.'); ",
"INSERT INTO user_permissions (permission_id, short_description, long_description) VALUES (3, 'Edit Any Category', 'User may edit (Create, Rename, Move, Delete) any Category in the system.'); ",


"INSERT INTO categories (category_id, parent, name) VALUES ('0', '-1', 'All Categories'); ",
"INSERT INTO categories (category_id, parent, name) VALUES ('0', '0', 'None'); ",
"UPDATE categories SET category_id = 0 WHERE parent = -1 AND name='All Categories'; ",
"UPDATE categories SET category_id = 1 WHERE name='None'; ",


"INSERT INTO users (user_id, user_name, user_name_lower, password, email, create_utime) VALUES (1, 'admin', 'admin', 'change_me', 'change_me', '1064093171'); ",
"INSERT INTO user_access_grants (user_id, permission_id, granter_user_id, grant_utime) VALUES (1, 0, 0, '1064093171'); ",

"INSERT INTO users (user_id, user_name, user_name_lower, password, email, create_utime) VALUES (2, 'scanner - (www.cooking.com)', 'cooking.com', 'change_me', 'change_me', '1064093171'); ",
"INSERT INTO user_access_grants (user_id, permission_id, granter_user_id, grant_utime) VALUES (2, 0, 1, '1064093171'); ",


"" };

    cnt = 0;
    while ( (thequery=dbquery[cnt++]) != "" ) {
        query.prepare(thequery);
        query.exec();
        if (query.lastError().type() != QSqlError::None) {
            QString msg =
                QString("DB Error \n"
                        "Query was: %1 \nError was: %2 \n")
                .arg(thequery)
                .arg(MythContext::DBErrorMessage(query.lastError()));
            VERBOSE(VB_IMPORTANT, msg);
        } else
            cout << QString("[%1] (%2) ").arg(cnt).arg(thequery) << endl;
    }
}

