#include "menu.h"


QString Amount::value() {
    QString retstr;
    QTextStream ts(&retstr, IO_WriteOnly);

    if (a_qty==0.0) {
        if ( range().zero() ) {
            ts << "none" ;
        } else {
            ts  << range().from() <<" to "
                 << range().to()   << " " << a_unit << " "
                 << a_size;
        }
    } else {
        // quantity defined so display it
        ts << a_qty << " " << a_unit << " " << a_size;
    }
    return retstr;
}



void Amount::display(QString str) {
    // cout << "****************** Start Amount ***************";
    if (a_qty==0.0) {
        if ( range().zero() ) {
            cout << str << "Empty Amount Item..." << endl;
        } else {
            cout << str << "amt Range.. (" << range().from() <<") to ("
                 << range().to()   << ") to (" << a_unit << ") ("
                 << a_size << ") "  << endl;
        }
    } else {
        // quantity defined so display it
        cout << str << "amt Qty... (" << a_qty << ") ("
             << a_unit << ") (" 
	     << a_size << ") ..." << endl;
    }
    // cout << "****************** End Amount ***************";
}



void Header::display(QString str)  {
    cout << str << "*****************>  Start Header  <***********" << endl;
    cout << str << "Title:     " << title << endl;
    cout << str << "Sub Title: " << sub_title << endl;
    cout << str << "Version:   " << version << endl;
    cout << str << "source:    " << source << endl;
    cout << str << "Yield:     " << yield.value() << endl;
    cout << str << "Category: (" << category.size() << ") ";
    for (QStringList::Iterator it=category.begin();
                               it!=category.end(); ++it) {
        cout << str << (*it) << ", ";
    }
    cout << str << endl;
    cout << str << "PrepTime: " << preptime.size();
    for (QStringList::Iterator it=preptime.begin();
                               it!=preptime.end(); ++it) {
        cout << str << (*it) << " ";
    }
    cout << str << endl;
    cout << str << "*****************>  End Header  <***********" << endl;
}




//***********************************************************
// P R E P T I M E       Class Methods   
//***********************************************************
        
PrepTime::PrepTime() {

}

PrepTime::~PrepTime() {

}

//***********************************************************
//  I N G I T E M       Class Methods   
//***********************************************************
        
IngItem::IngItem() 
	: type(""),
	  item("0"),
	  prep("0"),
	  modifier("0")
{ }


IngItem::~IngItem() {

}

void IngItem::display(QString str) 
{
    cout << str << "*****************>  Start IngItem  <***********" << endl;
    // cout << str << "Number of amt: (" << amt.size() << ") \n";
    for (QValueList<Amount>::Iterator it=amt.begin();
                              it!=amt.end(); ++it) {
         (*it).display(str);
    }
    cout << str << "Type: (" << type << ") " << endl;
    cout << str << "Item: (" << item << ") " << endl;
    cout << str << "prep: (" << prep << ") " << endl;
    cout << str << "modifier: (" << modifier << ") " << endl;
    /*
    // cout << str <<"Number of alt_ing: (" << alt_ing.size() << ") ";
    cout << str << "Alternate ingredients" << endl;
    for (QValueList<IngItem>::Iterator it=alt_ing.begin();
                              it!=alt_ing.end(); ++it) {
         (*it).display(str+str);
    }
    */
    cout << str << endl;
    cout << str << "*****************>  End IngItem  <***********" << endl;
    cout << str << endl;
}

//***********************************************************
//  I N G R E D I E N T        Class Methods   
//***********************************************************

Ingredient::~Ingredient() {

}
        
void Ingredient::display(QString str)  {
    int cnt;
    cout << str << "*****************>  Start Ingredients  <***********"<<endl;
    cout << str << "Title      : " << title << endl;
    cout << str << "Description: " << description << endl;
    cout << str << "Notes: " << endl;
    for (QStringList::Iterator it=notes.begin();
                               it!=notes.end(); ++it) {
        cout << str << (*it) << " ";
    }
    cnt=0;
    for (QValueList<IngItem>::Iterator it=ing_items.begin();
                              it!=ing_items.end(); ++it) {
         cout << str << "Ing-Item:  (" << ++cnt << ") " << endl;
         cout << str << "-----------------------------" << endl;
         (*it).display(str+str);
    }
    cout << str << "*****************>  End Ingredients  <***********"<<endl;
}

//***********************************************************
//  R E C I P E      Class Methods   
//***********************************************************
Recipe::Recipe() {

}

Recipe::~Recipe() {

}


void Recipe::display(QString str) {
    int cnt=0;
    cout << str << "****************   Start Recipes   *************" <<endl;
    header.display(str);
    cnt=0;
    for (QValueList<Ingredient>::Iterator it=ingredients.begin();
                               it!=ingredients.end(); ++it) {
        cout << str << "Ingredient number (" << ++cnt << ") " <<  endl;;
        cout << str << "----------------------------------" << endl;
        (*it).display(str+str);
    }
    cnt=0;
    cout << str << "Directions " <<  endl;;
    cout << str << "----------------------------------" << endl;
    for (QValueList<QString>::Iterator it=directions.begin();
                               it!=directions.end(); ++it) {
        QStringList sl=QStringList::split(". ", (*it));

        for (QValueList<QString>::Iterator itt=sl.begin();
                                           itt!=sl.end(); ++itt) {
            cout << str << "(" << ++cnt << ")\t" 
                 << (*itt).simplifyWhiteSpace() << endl;
        }
    }
    
    cout << str << "****************   End Recipes   *************" <<endl;
}


Menu::Menu() {

}

Menu::~Menu() {

}


void Menu::display(QString str) {
    cout << str << "****************   Start Menu   *************" <<endl;
    header.display(str+str);

    for (QValueList<Recipe>::Iterator it=recipes.begin();
                               it!=recipes.end(); ++it) {
        (*it).display(str+str);
    }
    cout << str << "****************   End Menu   *************" <<endl;
}


QValueList<ShoppingList> &Menu::getShoppingList() {
    return shoppinglists;
}




void Menu::addDescription(Description) {

}



ShoppingList::ShoppingList() {

}

ShoppingList::~ShoppingList() {

}


void ShoppingList::addRecipeIngredients( Recipe ) {

}


void ShoppingList::resetShoppingList() {

}

