#include <mythtv/mythcontext.h>

#include "recipe_filter.h"
#include <qfile.h>
#include <qdialog.h>
#include <qcursor.h>
#include <qdir.h>
#include <qimage.h>

// General Settings

class RecipeNameFilter: public LineEditSetting, public GlobalSetting {
public:
    RecipeNameFilter():
        GlobalSetting("RecipeNameFilter") {
        setLabel(QObject::tr("Recipe Name Filter"));
        setValue("All");
        setHelpText(QObject::tr("Display recipes which include (text) in title.. "));
    };
};

class RecipeShowFavorites: public CheckBoxSetting, public GlobalSetting {
public:
    RecipeShowFavorites():
        GlobalSetting("RecipeShowFavourites") {
        setLabel(QObject::tr("Show Only Favorite Recipes"));
        setValue(false);
        setHelpText(QObject::tr("Show only Favourite (tagged) Recipes... " ));
    };
};

class RecipeCourseFilter: public LineEditSetting, public GlobalSetting {
public:
    RecipeCourseFilter():
        GlobalSetting("RecipeCourseFilter") {
        setLabel(QObject::tr("Recipe Course Filter"));
        setValue("All");
        setHelpText(QObject::tr("Display recipes which include (text) in Course title."));
    };
};

class RecipeCuisineFilter: public LineEditSetting, public GlobalSetting {
public:
    RecipeCuisineFilter():
        GlobalSetting("RecipeCuisineFilter") {
        setLabel(QObject::tr("Recipe Cuisine Filter"));
        setValue("All");
        setHelpText(QObject::tr("Display recipes which include (text) in Cuisine title."));
    };
};

class RecipeIngredientFilter: public LineEditSetting, public GlobalSetting {
public:
    RecipeIngredientFilter():
        GlobalSetting("RecipeIngredientFilter") {
        setLabel(QObject::tr("Recipe Ingredient Filter"));
        setValue("All");
      setHelpText(QObject::tr("Display recipes which include (text) in Ingredient name."));
    };
};

MythRecipeFilterSettings::MythRecipeFilterSettings()
{
    VerticalConfigurationGroup *filter = new VerticalConfigurationGroup(false);

    filter->setLabel(QObject::tr("MythRecipe Filter Settings "));

    filter->addChild( new RecipeNameFilter() );
    filter->addChild( new RecipeShowFavorites() );
    filter->addChild( new RecipeIngredientFilter() );
    filter->addChild( new RecipeCourseFilter() );
    filter->addChild( new RecipeCuisineFilter() );

    addChild(filter);
}
